/*
Exports tick data into a PostgreSQL database
    Copyright (C) 2015  Naddmr

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#property copyright "2014 Naddmr GPLV3"
#property link "http://www.forexfabrik.de"
#property indicator_chart_window 

#include <stdlib.mqh>
extern string	DBConfigFilePath="C:/Apps/FXCM MetaTrader 4/MQL4/Files/";
extern string	DBConfigFileName="PQWriter_DB_Config_FXCM.set";
extern bool 	isDebug=false;
extern string	LabelText="SQL-SHMPROC";
extern string	LabelSize=80;

#import "mt4psql_proc.dll"
	int pqInit(
		string	pConfigFileName,
		string	pEAName,
		string	pPairName,
		string	pBrokerName,
		int 	pIsDemo,
		double	pPoint,
		double	pDigits
	);
	//
	void pqDeInit(int pHdl);
	//
	void DispatchTick(
		int pHdl,
		MqlTick &pTick
	);
	int isValidHandle(int pHdl);
#import
static MqlTick this_tick, last_tick;
static int pqHandle=0;
static string pName="";

void init() {
	pName=WindowExpertName();
	if (ObjectFind(pName)<0) {
		ObjectCreate(pName, OBJ_LABEL, 0, 0, 0);
	}
	ObjectSetText(pName, LabelText, LabelSize, "Arial", Red);
	ObjectSet(pName, OBJPROP_BACK, true);
	ObjectSetInteger(0, pName, OBJPROP_SELECTABLE, false);
}

void deinit() {
	if (pqHandle!=0) {
		pqDeInit(pqHandle);
	}
	ObjectDelete(pName);
}

void start() {
	static string FullConfigFileName;
	static bool isSQLConnected=false;
	static bool isInitialized=false;
	if (!isSQLConnected) {
		// during startup of the terminal the AccountCompany() and 
		// other variables are not initialized properly.
		// So we have to wait until the startup is complete.
		if (AccountCompany()!="") {
			FullConfigFileName=DBConfigFilePath + DBConfigFileName;
			Print("start: Establishing connection ..." );
			pqHandle=pqInit(
				FullConfigFileName,
				"PQ_Writer_Proc",
				Symbol(),
				AccountCompany(),
				IsDemo(),
				Point,
				Digits
			);
			// Retry connection "if (!IsSQLConnected)"
			isSQLConnected=(isValidHandle(pqHandle)!=0);
			Print("start: Connectionhandle is " + pqHandle + " isValidHandle=" + isSQLConnected );
			if (!isSQLConnected) {
				Print("start: NOT CONNECTED! Cleaning up handle=" + pqHandle );
				pqDeInit(pqHandle);
				pqHandle=0;
				Sleep(500);
			} else {
				if (ObjectFind(pName)>=0) {
					ObjectSetText(pName, LabelText, LabelSize, "Arial", LightGray);
				}
			}
		}
	} else {
		if (isInitialized) {
			if (isDebug) {
				uint startT=GetTickCount();
			}
			if (SymbolInfoTick(Symbol(), this_tick)) {
				// Filter duplicate ticks during the same second.
				if (
					(this_tick.time!=last_tick.time) ||
					(this_tick.bid!=last_tick.bid) ||
					(this_tick.ask!=last_tick.ask) ||
					(this_tick.last!=last_tick.last) ||
					(this_tick.volume!=last_tick.volume)
				) {
					if (isDebug) {
						uint writeT=GetTickCount();
					}
					DispatchTick(pqHandle, this_tick);
				}
			}
		}
		last_tick=this_tick;
		isInitialized=true;
		if (isDebug) {
			uint endT=GetTickCount();
			Print("Writing took " + (endT-writeT) + " msecs, start took " + (endT-startT) + " msecs" );
		}
	}
}
